* Henter opp datasett for Norge
use "C:\Bacheloroppgave\data2901-Norway.dta", clear

* Legger alle landene i samme datasett
append using "data2901-Sweden.dta"
append using "data2901-Iceland.dta"

* Lagrer datasettet med alle landene
save data2901-Nor_Swe_Ice.dta

* Sorterer med hensyn på ID
sort idcntry

* Deskriptiv statistikk for avhengig variabel for landene
use "C:\Bacheloroppgave\data2901-Nor_Swe_Ice.dta", clear
by idcntry: sum read

* Histogram for Island
use "C:\Bacheloroppgave\data2901-Iceland.dta", clear
histogram read, freq ytitle(Antall elever) xtitle(read (testscore)) title (Fordeling av avhengig variabel for Island)

* Histogram for Norge
use "C:\Bacheloroppgave\data2901-Norway.dta", clear
histogram read, freq ytitle(Antall elever) xtitle(read (testscore)) title (Fordeling av avhengig variabel for Norge)

* Histogram for Sverige
use "C:\Bacheloroppgave\data2901-Sweden.dta", clear
histogram read, freq ytitle(Antall elever) xtitle(read (testscore)) title (Fordeling av avhengig variabel for Sverige)

* Deskriptiv statistikk for interessevariabel
use "C:\Bacheloroppgave\data2901-Nor_Swe_Ice.dta", clear
sort idcntry

* Genererer dummier for "teacher_age"
* dummy for under 25 år
gen Dteacher_agemin_25=0 if teacher_age!=.
replace Dteacher_agemin_25=1 if teacher_age==1
* dummy for 25-29 år
gen Dteacher_age25_29=0 if teacher_age!=.
replace Dteacher_age25_29=1 if teacher_age==2
* dummy for 30-39 år
gen Dteacher_age30_39=0 if teacher_age!=.
replace Dteacher_age30_39=1 if teacher_age==3
* dummy for 40-49 år
gen Dteacher_age40_49=0 if teacher_age!=.
replace Dteacher_age40_49=1 if teacher_age==4
* dummy for 50-59 år
gen Dteacher_age50_59=0 if teacher_age!=.
replace Dteacher_age50_59=1 if teacher_age==5
* dummy for 60 eller mer år
gen Dteacher_age60_plus=0 if teacher_age!=.
replace Dteacher_age60_plus=1 if teacher_age==6

by idcntry: sum Dteacher_agemin_25 Dteacher_age25_29 Dteacher_age30_39 Dteacher_age40_49 Dteacher_age50_59 Dteacher_age60_plus

* Slår sammen og endrer til 3 dummyvariabler (ekskluderer kategori under 25 år - sammenligningskategori)
* Dummy for 25-29 år - Allerede definert over
* Dummy for 30-39 år - Allerede definert over
* Dummy for 40-49 år - Allerede definert over
* Dummy for 50 år og eldre
gen Dteacher_age50_plus=0 if teacher_age!=.
replace Dteacher_age50_plus=1 if teacher_age==5|teacher_age==6

* Endrer navn på kategorivariabler
rename Dteacher_age25_29 Fra_25_til_29_år
rename Dteacher_age30_39 Fra_30_til_39_år
rename Dteacher_age40_49 Fra_40_til_49_år
rename Dteacher_age50_plus Fra_50_år_og_over

* Deskriptiv statistikk for nye kategorier/dummyvariabler
by idcntry: sum Fra_25_til_29_år Fra_30_til_39_år Fra_40_til_49_år Fra_50_år_og_over

* Bar chart for de 4 kategoriene i teacher_age
graph bar (mean) Fra_25_til_29_år Fra_30_til_39_år Fra_40_til_49_år Fra_50_år_og_over, over(idcntry) ytitle(Antall lærere i prosent) title(Gjennomsnittlig fordeling av lærere for ulike aldersgrupper)

* Tester sammenheng mellom teacher_age og teacher_exp
scatter teacher_age teacher_exp, title(Kryssplot for læreralder og lærererfaring)|| lfit teacher_age teacher_exp
corr teacher_age teacher_exp

* Deskriptiv statistikk for teacher_exp
by idcntry: sum teacher_exp

* Kryssplot for Island
use "C:\Bacheloroppgave\data2901-Iceland.dta", clear
scatter read teacher_exp, title(Kryssplot for testscore og lærererfaring for Island)|| lfit read teacher_exp
corr read teacher_exp

* Kryssplot for Norge
use "C:\Bacheloroppgave\data2901-Norway.dta", clear
scatter read teacher_exp, title(Kryssplot for testscore og lærererfaring for Norge)|| lfit read teacher_exp
corr read teacher_exp

* Kryssplot for Sverige
use "C:\Bacheloroppgave\data2901-Sweden.dta", clear
scatter read teacher_exp, title(Kryssplot for testscore og lærererfaring for Sverige)|| lfit read teacher_exp
corr read teacher_exp

* Forskjell mellom jenter og gutter
* Island
use "C:\Bacheloroppgave\data2901-Iceland.dta", clear
twoway (scatter read teacher_exp if girl==0, mcolor(blue) msymbol(t)) (lfit read teacher_exp if girl==0, color(blue)) (scatter read teacher_exp if girl==1, mcolor(red)) (lfit read teacher_exp if girl==1, color(red))
corr read teacher_exp if girl==0
corr read teacher_exp if girl==1
* Norge
use "C:\Bacheloroppgave\data2901-Norway.dta", clear
twoway (scatter read teacher_exp if girl==0, mcolor(blue) msymbol(t)) (lfit read teacher_exp if girl==0, color(blue)) (scatter read teacher_exp if girl==1, mcolor(red)) (lfit read teacher_exp if girl==1, color(red))
corr read teacher_exp if girl==0
corr read teacher_exp if girl==1
* Sverige
use "C:\Bacheloroppgave\data2901-Sweden.dta", clear
twoway (scatter read teacher_exp if girl==0, mcolor(blue) msymbol(t)) (lfit read teacher_exp if girl==0, color(blue)) (scatter read teacher_exp if girl==1, mcolor(red)) (lfit read teacher_exp if girl==1, color(red))
corr read teacher_exp if girl==0
corr read teacher_exp if girl==1

* Forskjell mellom elever født i utlandet og elever som ikke er født i utlandet
* Island
use "C:\Bacheloroppgave\data2901-Iceland.dta", clear
twoway (scatter read teacher_exp if not_born==0, mcolor(green) msymbol(t)) (lfit read teacher_exp if not_born==0, color(green)) (scatter read teacher_exp if not_born==1, mcolor(red)) (lfit read teacher_exp if not_born==1, color(red))
corr read teacher_exp if not_born==0
corr read teacher_exp if not_born==1
* Norge
use "C:\Bacheloroppgave\data2901-Norway.dta", clear
twoway (scatter read teacher_exp if not_born==0, mcolor(green) msymbol(t)) (lfit read teacher_exp if not_born==0, color(green)) (scatter read teacher_exp if not_born==1, mcolor(red)) (lfit read teacher_exp if not_born==1, color(red))
corr read teacher_exp if not_born==0
corr read teacher_exp if not_born==1
* Sverige
use "C:\Bacheloroppgave\data2901-Sweden.dta", clear
twoway (scatter read teacher_exp if not_born==0, mcolor(green) msymbol(t)) (lfit read teacher_exp if not_born==0, color(green)) (scatter read teacher_exp if not_born==1, mcolor(red)) (lfit read teacher_exp if not_born==1, color(red))
corr read teacher_exp if not_born==0
corr read teacher_exp if not_born==1

* Deskriptiv statistikk for kontrollvariabler for landene
use "C:\Bacheloroppgave\data2901-Nor_Swe_Ice.dta", clear
sort idcntry
* Deskriptiv statistikk girl
by idcntry: sum read if girl==1
by idcntry: sum read if girl==0
graph box read, over(girl) over(idcntry) ytitle(Read (testscore)) title(Box plot for testscore og lærerens alder for alle land)
* Deskriptiv statistikk not_born
by idcntry: sum read if not_born==1
by idcntry: sum read if not_born==0
graph box read, over(not_born) over(idcntry) ytitle(Read (testscore)) title(Box plot for testscore og elever født i utlandet for alle land)
* Deskriptiv statistikk par_not_born
by idcntry: sum read if par_not_born==1
by idcntry: sum read if par_not_born==0
graph box read, over(par_not_born) over(idcntry) ytitle(Read (testscore)) title(Box plot for testscore og elever m/utenlandske foreldre for alle land)

* Korrelasjonsmatrise for teacher_exp
use "C:\Bacheloroppgave\data2901-Nor_Swe_Ice.dta", clear
sort idcntry
by idcntry: corr read teacher_exp girl not_born par_not_born

* Eksempel for å illustrere utelatt variabelproblem (utelater kontrollvariabler girl og not_born)
by idcntry: corr read teacher_exp par_not_born

* Tester om interessevariabel er statistisk signifkant for landene
use "C:\Bacheloroppgave\data2901-Norway.dta", clear
reg read teacher_exp 
ttest teacher_exp=0

use "C:\Bacheloroppgave\data2901-Iceland.dta", clear
reg read teacher_exp
ttest teacher_exp=0

use "C:\Bacheloroppgave\data2901-Sweden.dta", clear
reg read teacher_exp
ttest teacher_exp=0

* Estimering av ulike modellvarianter for teacher_exp
use "C:\Bacheloroppgave\data2901-Nor_Swe_Ice.dta", clear

* Lager dummier for landene Island og Sverige, med Norge som referanseland
gen DIsland=0
replace DIsland=1 if idcntry==352
gen DSverige=0
replace DSverige=1 if idcntry==752

* Estimerer
reg read teacher_exp
est store i
reg read teacher_exp DIsland DSverige
est store ii
reg read teacher_exp DIsland DSverige girl not_born par_not_born 
est store iii
test girl not_born par_not_born
ttest girl=0
ttest not_born=0
ttest par_not_born=0
ttest not_born=par_not_born

gen girl_teacher_exp=girl*teacher_exp
reg read teacher_exp DIsland DSverige girl_teacher_exp girl not_born par_not_born 
est store iv
ttest girl_teacher_exp=0

gen not_born_teacher_exp=not_born*teacher_exp
reg read teacher_exp DIsland DSverige girl_teacher_exp not_born_teacher_exp girl not_born par_not_born 
est store v
ttest not_born_teacher_exp=0
test girl_teacher_exp not_born_teacher_exp

gen DIsland_teacher_exp=DIsland*teacher_exp
reg read teacher_exp DIsland DSverige DIsland_teacher_exp girl not_born par_not_born
est store vi
ttest DIsland_teacher_exp=0

gen DSverige_teacher_exp=DSverige*teacher_exp
reg read teacher_exp DIsland DSverige DIsland_teacher_exp DSverige_teacher_exp girl not_born par_not_born 
est store vii
ttest DSverige_teacher_exp=0

gen teacher_exp_sq=teacher_exp*teacher_exp
gen girl_teacher_exp_sq=girl*teacher_exp_sq
gen not_born_teacher_exp_sq=not_born*teacher_exp_sq

reg read teacher_exp DIsland DSverige teacher_exp_sq girl_teacher_exp girl_teacher_exp_sq girl not_born par_not_born 
est store viii
test teacher_exp_sq

* Beregner marginaleffekt av teacher_exp for jente i Norge:
display 0.289+2*0.005*16.5-0.058+2*0.002*16.5
* Beregner marginaleffekt av teacher_exp for gutt i Norge:
display 0.289+2*0.005*16.5
* Beregner marginaleffekt av teacher_exp for jente på Island:
display 0.289+2*0.005*13-0.058+2*0.002*13
* Beregner marginaleffekt av teacher_exp for gutt på Island:
display 0.289+2*0.005*13
* Beregne marginaleffekt av teacher_exp for jente i Sverige:
display 0.289+2*0.005*15.4-0.058+2*0.002*15.4
* Beregner marginaleffekt av teacher_exp for gutt i Sverige:
display 0.289+2*0.005*15.4

reg read teacher_exp DIsland DSverige teacher_exp_sq not_born_teacher_exp not_born_teacher_exp_sq girl not_born par_not_born 
est store ix
test teacher_exp_sq

* Beregner marginaleffekt av teacher_exp for elever som ikke er født i Norge:
display 0.410+2*0.009*16.5-1.151+2*0.038*16.5
* Beregner marginaleffekt av teacher_exp for elever som er født i Norge:
display 0.410+2*0.009*16.5
* Beregner marginaleffekt av teacher_exp for elever som ikke er født på Island:
display 0.410+2*0.009*13-1.151+2*0.038*13
* Beregner marginaleffekt av teacher_exp for elever som er født på Island:
display 0.410+2*0.009*13
* Beregner marginaleffekt av teacher_exp for elever som ikke er født i Sverige:
display 0.410+2*0.009*15.4-1.151+2*0.038*15.4
* Beregner marginaleffekt av teacher_exp for elever som er født i Sverige:
display 0.410+2*0.009*15.4

* Estimering av utvidede modellvarianter for teacher_exp
reg read teacher_exp DIsland DSverige girl not_born par_not_born clsize pc_class 
est store x
test clsize pc_class

esttab i ii iii iv v vi vii viii ix x, r2 se nostar b(3) title(Regresjonstabell for teacher_exp)

cd "C:\Bacheloroppgave"
esttab i ii iii iv v vi vii viii ix x using resultattabell.doc, r2 se nostar b(3) title(Regresjonstabell for teacher_exp)


